Public Member Functions

# OGRMutexedDataSource Class Reference

`#include <ogrmutexeddatasource.h>`

Inheritance diagram for OGRMutexedDataSource:

List of all members.

## Public Member Functions
virtual const char * | GetName ()
| Returns the name of the data source.
virtual int | GetLayerCount ()
| Get the number of layers in this data source.
virtual OGRLayer * | GetLayer (int)
| Fetch a layer by index.
virtual OGRLayer * | GetLayerByName (const char *)
| Fetch a layer by name.
virtual OGRErr | DeleteLayer (int)
| Delete the indicated layer from the datasource.
virtual int | TestCapability (const char *)
| Test if capability is available.
virtual OGRLayer * | CreateLayer (const char *pszName, OGRSpatialReference *poSpatialRef=NULL, OGRwkbGeometryType eGType=wkbUnknown, char **papszOptions=NULL)
| This method attempts to create a new layer on the data source with the indicated name, coordinate system, geometry type.
virtual OGRLayer * | CopyLayer (OGRLayer *poSrcLayer, const char *pszNewName, char **papszOptions=NULL)
| Duplicate an existing layer.
virtual OGRStyleTable * | GetStyleTable ()
| Returns data source style table.
virtual void | SetStyleTableDirectly (OGRStyleTable *poStyleTable)
| Set data source style table.
virtual void | SetStyleTable (OGRStyleTable *poStyleTable)
| Set data source style table.
virtual OGRLayer * | ExecuteSQL (const char *pszStatement, OGRGeometry *poSpatialFilter, const char *pszDialect)
| Execute an SQL statement against the data store.
virtual void | ReleaseResultSet (OGRLayer *poResultsSet)
| Release results of ExecuteSQL().
virtual OGRErr | SyncToDisk ()
| Flush pending changes to disk.

## Detailed Description

OGRMutexedDataSource class protects all virtual methods of OGRDataSource with a mutex. If the passed mutex is NULL, then no locking will be done.

Note that the constructors and destructors are not explictely protected by the mutex*

## Member Function Documentation

OGRLayer * OGRMutexedDataSource::CopyLayer | ( | OGRLayer * | poSrcLayer,
|  | const char * | pszNewName,
|  | char ** | papszOptions = `NULL` |
| ) |  |  | `[virtual]`

Duplicate an existing layer.

This method creates a new layer, duplicate the field definitions of the source layer and then duplicate each features of the source layer. The papszOptions argument can be used to control driver specific creation options. These options are normally documented in the format specific documentation. The source layer may come from another dataset.

This method is the same as the C function OGR_DS_CopyLayer().

Parameters:

  | poSrcLayer | source layer.
  | pszNewName | the name of the layer to create.
  | papszOptions | a StringList of name=value options. Options are driver specific.

Returns:
  an handle to the layer, or NULL if an error occurs.

Reimplemented from OGRDataSource.

References OGRDataSource::CopyLayer().

OGRLayer * OGRMutexedDataSource::CreateLayer | ( | const char * | pszName,
|  | OGRSpatialReference * | poSpatialRef = `NULL`,
|  | OGRwkbGeometryType | eGType = `wkbUnknown`,
|  | char ** | papszOptions = `NULL` |
| ) |  |  | `[virtual]`

This method attempts to create a new layer on the data source with the indicated name, coordinate system, geometry type.

The papszOptions argument can be used to control driver specific creation options. These options are normally documented in the format specific documentation.

Parameters:

  | pszName | the name for the new layer. This should ideally not match any existing layer on the datasource.
  | poSpatialRef | the coordinate system to use for the new layer, or NULL if no coordinate system is available.
  | eGType | the geometry type for the layer. Use wkbUnknown if there are no constraints on the types geometry to be written.
  | papszOptions | a StringList of name=value options. Options are driver specific.

Returns:
  NULL is returned on failure, or a new OGRLayer handle on success.

Example:

    #include "ogrsf_frmts.h"
    #include "cpl_string.h"

    ...

            OGRLayer *poLayer;
            char     **papszOptions;

            if( !poDS->TestCapability( ODsCCreateLayer ) )
            {
            ...
            }

            papszOptions = CSLSetNameValue( papszOptions, "DIM", "2" );
            poLayer = poDS->CreateLayer( "NewLayer", NULL, wkbUnknown,
                                         papszOptions );
            CSLDestroy( papszOptions );

            if( poLayer == NULL )
            {
                ...
            }

Reimplemented from OGRDataSource.

References OGRDataSource::CreateLayer().

OGRErr OGRMutexedDataSource::DeleteLayer | ( | int | iLayer | ) | `[virtual]`

Delete the indicated layer from the datasource.

If this method is supported the ODsCDeleteLayer capability will test TRUE on the OGRDataSource.

This method is the same as the C function OGR_DS_DeleteLayer().

Parameters:

  | iLayer | the index of the layer to delete.

Returns:
  OGRERR_NONE on success, or OGRERR_UNSUPPORTED_OPERATION if deleting layers is not supported for this datasource.

Reimplemented from OGRDataSource.

References OGRDataSource::DeleteLayer().

OGRLayer * OGRMutexedDataSource::ExecuteSQL | ( | const char * | pszStatement,
|  | OGRGeometry * | poSpatialFilter,
|  | const char * | pszDialect |
| ) |  |  | `[virtual]`

Execute an SQL statement against the data store.

The result of an SQL query is either NULL for statements that are in error, or that have no results set, or an OGRLayer pointer representing a results set from the query. Note that this OGRLayer is in addition to the layers in the data store and must be destroyed with OGRDataSource::ReleaseResultSet() before the data source is closed (destroyed).

This method is the same as the C function OGR_DS_ExecuteSQL().

For more information on the SQL dialect supported internally by OGR review the OGR SQL document. Some drivers (ie. Oracle and PostGIS) pass the SQL directly through to the underlying RDBMS.

Starting with OGR 1.10, the SQLITE dialect can also be used.

Parameters:

  | pszStatement | the SQL statement to execute.
  | poSpatialFilter | geometry which represents a spatial filter. Can be NULL.
  | pszDialect | allows control of the statement dialect. If set to NULL, the OGR SQL engine will be used, except for RDBMS drivers that will use their dedicated SQL engine, unless OGRSQL is explicitely passed as the dialect. Starting with OGR 1.10, the SQLITE dialect can also be used.

Returns:
  an OGRLayer containing the results of the query. Deallocate with ReleaseResultSet().

Reimplemented from OGRDataSource.

References OGRDataSource::ExecuteSQL().

OGRLayer * OGRMutexedDataSource::GetLayer | ( | int | iLayer | ) | `[virtual]`

Fetch a layer by index.

The returned layer remains owned by the OGRDataSource and should not be deleted by the application.

This method is the same as the C function OGR_DS_GetLayer().

Parameters:

  | iLayer | a layer number between 0 and GetLayerCount()-1.

Returns:
  the layer, or NULL if iLayer is out of range or an error occurs.

Implements OGRDataSource.

References OGRDataSource::GetLayer().

OGRLayer * OGRMutexedDataSource::GetLayerByName | ( | const char * | pszLayerName | ) | `[virtual]`

Fetch a layer by name.

The returned layer remains owned by the OGRDataSource and should not be deleted by the application.

This method is the same as the C function OGR_DS_GetLayerByName().

Parameters:

  | pszLayerName | the layer name of the layer to fetch.

Returns:
  the layer, or NULL if Layer is not found or an error occurs.

Reimplemented from OGRDataSource.

References OGRDataSource::GetLayerByName().

int OGRMutexedDataSource::GetLayerCount | ( |  | ) | `[virtual]`

Get the number of layers in this data source.

This method is the same as the C function OGR_DS_GetLayerCount().

Returns:
  layer count.

Implements OGRDataSource.

References OGRDataSource::GetLayerCount().

const char * OGRMutexedDataSource::GetName | ( |  | ) | `[virtual]`

Returns the name of the data source.

This string should be sufficient to open the data source if passed to the same OGRSFDriver that this data source was opened with, but it need not be exactly the same string that was used to open the data source. Normally this is a filename.

This method is the same as the C function OGR_DS_GetName().

Returns:
  pointer to an internal name string which should not be modified or freed by the caller.

Implements OGRDataSource.

References OGRDataSource::GetName().

OGRStyleTable * OGRMutexedDataSource::GetStyleTable | ( |  | ) | `[virtual]`

Returns data source style table.

This method is the same as the C function OGR_DS_GetStyleTable().

Returns:
  pointer to a style table which should not be modified or freed by the caller.

Reimplemented from OGRDataSource.

References OGRDataSource::GetStyleTable().

void OGRMutexedDataSource::ReleaseResultSet | ( | OGRLayer * | poResultsSet | ) | `[virtual]`

Release results of ExecuteSQL().

This method should only be used to deallocate OGRLayers resulting from an ExecuteSQL() call on the same OGRDataSource. Failure to deallocate a results set before destroying the OGRDataSource may cause errors.

This method is the same as the C function OGR_L_ReleaseResultSet().

Parameters:

  | poResultsSet | the result of a previous ExecuteSQL() call.

Reimplemented from OGRDataSource.

References OGRDataSource::ReleaseResultSet().

void OGRMutexedDataSource::SetStyleTable | ( | OGRStyleTable * | poStyleTable | ) | `[virtual]`

Set data source style table.

This method operate exactly as OGRDataSource::SetStyleTableDirectly() except that it does not assume ownership of the passed table.

This method is the same as the C function OGR_DS_SetStyleTable().

Parameters:

  | poStyleTable | pointer to style table to set

Reimplemented from OGRDataSource.

References OGRDataSource::SetStyleTable().

void OGRMutexedDataSource::SetStyleTableDirectly | ( | OGRStyleTable * | poStyleTable | ) | `[virtual]`

Set data source style table.

This method operate exactly as OGRDataSource::SetStyleTable() except that it assumes ownership of the passed table.

This method is the same as the C function OGR_DS_SetStyleTableDirectly().

Parameters:

  | poStyleTable | pointer to style table to set

Reimplemented from OGRDataSource.

References OGRDataSource::SetStyleTableDirectly().

OGRErr OGRMutexedDataSource::SyncToDisk | ( |  | ) | `[virtual]`

Flush pending changes to disk.

This call is intended to force the datasource to flush any pending writes to disk, and leave the disk file in a consistent state. It would not normally have any effect on read-only datasources.

Some data sources do not implement this method, and will still return OGRERR_NONE. An error is only returned if an error occurs while attempting to flush to disk.

The default implementation of this method just calls the SyncToDisk() method on each of the layers. Conceptionally, calling SyncToDisk() on a datasource should include any work that might be accomplished by calling SyncToDisk() on layers in that data source.

In any event, you should always close any opened datasource with OGRDataSource::DestroyDataSource() that will ensure all data is correctly flushed.

This method is the same as the C function OGR_DS_SyncToDisk().

Returns:
  OGRERR_NONE if no error occurs (even if nothing is done) or an error code.

Reimplemented from OGRDataSource.

References OGRDataSource::SyncToDisk().

int OGRMutexedDataSource::TestCapability | ( | const char * | pszCapability | ) | `[virtual]`

Test if capability is available.

One of the following data source capability names can be passed into this method, and a TRUE or FALSE value will be returned indicating whether or not the capability is available for this object.

- ODsCCreateLayer: True if this datasource can create new layers.

- ODsCDeleteLayer: True if this datasource can delete existing layers.

- ODsCCreateGeomFieldAfterCreateLayer: True if the layers of this datasource support CreateGeomField() just after layer creation.

The #define macro forms of the capability names should be used in preference to the strings themselves to avoid mispelling.

This method is the same as the C function OGR_DS_TestCapability().

Parameters:

  | pszCapability | the capability to test.

Returns:
  TRUE if capability available otherwise FALSE.

Implements OGRDataSource.

References OGRDataSource::TestCapability().

The documentation for this class was generated from the following files:

- ogrmutexeddatasource.h
- ogrmutexeddatasource.cpp

Generated for GDAL by 1.7.1.